/* vi: set sw=2 ts=8: */
/*
 * Copyright 2005 by HI Corporation.
 *
 * This source code may be used for any purpose as long as this
 * copyright message remains in the source code and the documentation
 * for any product made from it includes a note stating:
 *
 * 	"Incorporates software from HI Corporation, copyright 2005."
 * 
 * This code comes WITHOUT warranty of merchantability or fitness for
 * a particular purpose.
 */

/* Sample Program accompanying the Using M3G section of Siggraph 2005
 * course #35.
 */

import java.io.IOException;
import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;

/**
 * Cans.
 *
 * Display 3 animated milk-coffee cans. 1, 2 & 3 keys
 * are used to pause and resume animation of the can above
 * the key that is pressed. The arrow keys are used to
 * move the camera.
 */
public class Cans extends MIDlet implements CommandListener 
{ 
  Command cmdExit = new Command("Exit", Command.SCREEN, 1);
  Command cmdPlayPause = new Command("Ctrl", Command.SCREEN, 1);
  private TargetCanvas tcanvas = null;  
  Thread renderingT = null;
  private String Filename = "/coffee.m3g";

  public void init()
  {
    Display disp = Display.getDisplay(this);
    tcanvas = new TargetCanvas(Filename);
    if (tcanvas.hasException)
      notifyDestroyed();
    tcanvas.setCommandListener(this);
    tcanvas.addCommand(cmdExit);
    tcanvas.addCommand(cmdPlayPause);
    disp.setCurrent(tcanvas);
  }

  
  public void startApp() 
  { 
     if (tcanvas == null)
       init();

     renderingT = new Thread(tcanvas);
     renderingT.start();
     tcanvas.startPlay();
  }


  public void pauseApp() 
  {
    if (tcanvas.isPlaying)
      tcanvas.pausePlay();
    renderingT.yield();
    renderingT = null;
  }
  

  public void destroyApp(boolean u) 
  {
    pauseApp();
    tcanvas = null;
  }


  synchronized public void commandAction(Command c, Displayable d)
  {
    if (c==cmdExit) {
      notifyDestroyed();
      return;
    } else if (c==cmdPlayPause) {
      if (tcanvas.isPlaying)
    	tcanvas.pausePlay();
      else
    	tcanvas.startPlay();
    }
  }

}
